// ignore_for_file: camel_case_types, constant_identifier_names, non_constant_identifier_names, unnecessary_this
import './List.dart' as list_mod;
import './Seq.dart' as seq_mod;
import './Types.dart' as types_mod;

Iterable<$T> distinct<$T>(Iterable<$T> xs, types_mod.IEqualityComparer<$T> comparer) => seq_mod.delay<$T>(() {
    final hashSet = types_mod.setWith(comparer);
    return seq_mod.filter<$T>(($T x) => hashSet.add(x), xs);
});

Iterable<$T> distinctBy<$T, $Key>($Key Function($T) projection, Iterable<$T> xs, types_mod.IEqualityComparer<$Key> comparer) => seq_mod.delay<$T>(() {
    final hashSet = types_mod.setWith(comparer);
    return seq_mod.filter<$T>(($T x) => hashSet.add(projection(x)), xs);
});

Iterable<$T> except<$T>(Iterable<$T> itemsToExclude, Iterable<$T> xs, types_mod.IEqualityComparer<$T> comparer) => seq_mod.delay<$T>(() {
    final hashSet = types_mod.setWith(comparer, itemsToExclude);
    return seq_mod.filter<$T>(($T x) => hashSet.add(x), xs);
});

Iterable<types_mod.Tuple2<$Key, int>> countBy<$T, $Key>($Key Function($T) projection, Iterable<$T> xs, types_mod.IEqualityComparer<$Key> comparer) => seq_mod.delay<types_mod.Tuple2<$Key, int>>(() {
    final dict = types_mod.mapWith<$Key, int>(comparer);
    final keys = <$Key>[];
    final enumerator = xs.iterator;
    try {
        while (enumerator.moveNext()) {
            final key = projection(enumerator.current);
            if (dict.containsKey(key)) {
                dict[key] = types_mod.getValue(dict, key) + 1;
            } else {
                dict[key] = 1;
                keys.add(key);
            }
        }
    } finally {
        if (enumerator is types_mod.IDisposable) {
            types_mod.dispose(enumerator);
        }
    }
    return seq_mod.map<$Key, types_mod.Tuple2<$Key, int>>(($Key key_1) => types_mod.Tuple2(key_1, types_mod.getValue(dict, key_1)), keys);
});

Iterable<types_mod.Tuple2<$Key, Iterable<$T>>> groupBy<$T, $Key>($Key Function($T) projection, Iterable<$T> xs, types_mod.IEqualityComparer<$Key> comparer) => seq_mod.delay<types_mod.Tuple2<$Key, Iterable<$T>>>(() {
    final dict = types_mod.mapWith<$Key, List<$T>>(comparer);
    final keys = <$Key>[];
    final enumerator = xs.iterator;
    try {
        while (enumerator.moveNext()) {
            final x = enumerator.current;
            final key = projection(x);
            if (dict.containsKey(key)) {
                types_mod.getValue(dict, key).add(x);
            } else {
                dict[key] = [x];
                keys.add(key);
            }
        }
    } finally {
        if (enumerator is types_mod.IDisposable) {
            types_mod.dispose(enumerator);
        }
    }
    return seq_mod.map<$Key, types_mod.Tuple2<$Key, Iterable<$T>>>(($Key key_1) => types_mod.Tuple2(key_1, types_mod.getValue(dict, key_1)), keys);
});

List<$T> Array_distinct<$T>(List<$T> xs, types_mod.IEqualityComparer<$T> comparer) => seq_mod.toArray<$T>(distinct<$T>(xs, comparer));

List<$T> Array_distinctBy<$T, $Key>($Key Function($T) projection, List<$T> xs, types_mod.IEqualityComparer<$Key> comparer) => seq_mod.toArray<$T>(distinctBy<$T, $Key>(projection, xs, comparer));

List<$T> Array_except<$T>(Iterable<$T> itemsToExclude, List<$T> xs, types_mod.IEqualityComparer<$T> comparer) => seq_mod.toArray<$T>(except<$T>(itemsToExclude, xs, comparer));

List<types_mod.Tuple2<$Key, int>> Array_countBy<$T, $Key>($Key Function($T) projection, List<$T> xs, types_mod.IEqualityComparer<$Key> comparer) => seq_mod.toArray<types_mod.Tuple2<$Key, int>>(countBy<$T, $Key>(projection, xs, comparer));

List<types_mod.Tuple2<$Key, List<$T>>> Array_groupBy<$T, $Key>($Key Function($T) projection, List<$T> xs, types_mod.IEqualityComparer<$Key> comparer) => seq_mod.toArray<types_mod.Tuple2<$Key, List<$T>>>(seq_mod.map<types_mod.Tuple2<$Key, Iterable<$T>>, types_mod.Tuple2<$Key, List<$T>>>((types_mod.Tuple2<$Key, Iterable<$T>> tupledArg) => types_mod.Tuple2(tupledArg.item1, seq_mod.toArray<$T>(tupledArg.item2)), groupBy<$T, $Key>(projection, xs, comparer)));

list_mod.FSharpList<$T> List_distinct<$T>(list_mod.FSharpList<$T> xs, types_mod.IEqualityComparer<$T> comparer) => seq_mod.toList<$T>(distinct<$T>(xs, comparer));

list_mod.FSharpList<$T> List_distinctBy<$T, $Key>($Key Function($T) projection, list_mod.FSharpList<$T> xs, types_mod.IEqualityComparer<$Key> comparer) => seq_mod.toList<$T>(distinctBy<$T, $Key>(projection, xs, comparer));

list_mod.FSharpList<$T> List_except<$T>(Iterable<$T> itemsToExclude, list_mod.FSharpList<$T> xs, types_mod.IEqualityComparer<$T> comparer) => seq_mod.toList<$T>(except<$T>(itemsToExclude, xs, comparer));

list_mod.FSharpList<types_mod.Tuple2<$Key, int>> List_countBy<$T, $Key>($Key Function($T) projection, list_mod.FSharpList<$T> xs, types_mod.IEqualityComparer<$Key> comparer) => seq_mod.toList<types_mod.Tuple2<$Key, int>>(countBy<$T, $Key>(projection, xs, comparer));

list_mod.FSharpList<types_mod.Tuple2<$Key, list_mod.FSharpList<$T>>> List_groupBy<$T, $Key>($Key Function($T) projection, list_mod.FSharpList<$T> xs, types_mod.IEqualityComparer<$Key> comparer) => seq_mod.toList<types_mod.Tuple2<$Key, list_mod.FSharpList<$T>>>(seq_mod.map<types_mod.Tuple2<$Key, Iterable<$T>>, types_mod.Tuple2<$Key, list_mod.FSharpList<$T>>>((types_mod.Tuple2<$Key, Iterable<$T>> tupledArg) => types_mod.Tuple2(tupledArg.item1, seq_mod.toList<$T>(tupledArg.item2)), groupBy<$T, $Key>(projection, xs, comparer)));

